import * as Minecraft from "@minecraft/server"
import * as MinecraftUi from "@minecraft/server-ui";

Minecraft.system.runInterval(() =>{
    for (const player of Minecraft.world.getPlayers()) {
        player.runCommandAsync("gamerule keepinventory false")
        player.runCommandAsync("gamerule dodaylightcycle true")
        player.runCommandAsync("gamerule doweathercycle true")
        player.runCommandAsync("gamerule commandblocksenabled true")
        player.runCommandAsync("spawnpoint @s[family=fault] 1000 0 1000")
        if(player.getGameMode() != `survival` && !player.hasTag(`JFDUM23CK5WHK===`)){
            if (!player.hasTag(`warning`)){
                Warning(player)
                player.addTag(`warning`)
            }
            player.setGameMode(`survival`)
        }
    }
}, 5)
function Warning(player){
    const form = new MinecraftUi.ActionFormData() 
        .title(`§cCheating detected`)
        .body(`§6Did you know that changing own gamemode is actually breaking the rules?\n\n\n\n\n\n\n\n\n\n `)
        .button(`§l§4Yes, I do.`)
    form.show(player).then((data) => {
        try {
            if (data.selection === 0) {
                player.removeTag(`warning`)
                player.sendMessage('§c§lFOLLOW RULES!')
            }
            else
                return Warning(player)
        } catch (e) {
            return Warning(player)
        }
    })

}
Minecraft.world.afterEvents.playerSpawn.subscribe((data) => {
    if (data.player.hasTag(`warning`)){
        Warning(data.player)
    }
    if (!data.player.hasTag(`book`)){
        data.player.runCommand(`loot give @s loot book`)
        data.player.addTag(`book`)
    }
})
Minecraft.world.beforeEvents.itemUse.subscribe(data => {
    if (data.itemStack.typeId == "add:void_totem") {
        data.source.runCommandAsync('tellraw @s[family=unskilled] {\"rawtext\":[{\"text\":\"§aTotem Protection Activated\"}]}')
        data.source.runCommandAsync('tellraw @s[family=totem] {\"rawtext\":[{\"text\":\"§eYou\'ve already used this Totem\"}]}')
        data.source.runCommandAsync('tellraw @s[family=guardian] {\"rawtext\":[{\"text\":\"§bYou\'ve already used §pVoid Guardian\"}]}')
        data.source.runCommandAsync('tellraw @s[family=slayer] {\"rawtext\":[{\"text\":\"§eYou\'ve already used §uVoid Slayer\"}]}')
        data.source.runCommandAsync('tellraw @s[family=fault] {\"rawtext\":[{\"text\":\"§o§cDON\'T KILL TRADERS!...\"}]}')
        data.source.runCommandAsync('event entity @s[family=unskilled] totem')
        data.source.runCommandAsync('clear @s[family=unskilled] add:void_totem 0 1')
    }
    if (data.itemStack.typeId == "add:void_guardian") {
        data.source.runCommandAsync('tellraw @s[family=unskilled] {\"rawtext\":[{\"text\":\"§bGuardian Protection Activated\"}]}')
        data.source.runCommandAsync('tellraw @s[family=totem] {\"rawtext\":[{\"text\":\"§dProtection Updated\"}]}')
        data.source.runCommandAsync('tellraw @s[family=guardian] {\"rawtext\":[{\"text\":\"§uYou\'ve already used this Totem\"}]}')
        data.source.runCommandAsync('tellraw @s[family=slayer] {\"rawtext\":[{\"text\":\"§dYou\'ve already used §2Void Slayer\"}]}')
        data.source.runCommandAsync('tellraw @s[family=fault] {\"rawtext\":[{\"text\":\"§o§cDON\'T KILL TRADERS!...\"}]}')
        data.source.runCommandAsync('event entity @s[family=unskilled] guardian')
        data.source.runCommandAsync('event entity @s[family=totem] guardian')
        data.source.runCommandAsync('clear @s[family=unskilled] add:void_guardian 0 1')
        data.source.runCommandAsync('clear @s[family=totem] add:void_guardian 0 1')
    }
    if (data.itemStack.typeId == "add:void_slayer") {
        data.source.runCommandAsync('tellraw @s[family=unskilled] {\"rawtext\":[{\"text\":\"§eSlayer Protection Activated\"}]}')
        data.source.runCommandAsync('tellraw @s[family=totem] {\"rawtext\":[{\"text\":\"§dProtection Updated\"}]}')
        data.source.runCommandAsync('tellraw @s[family=guardian] {\"rawtext\":[{\"text\":\"§aProtection Updated\"}]}')
        data.source.runCommandAsync('tellraw @s[family=slayer] {\"rawtext\":[{\"text\":\"§bYou\'ve already used this Totem\"}]}')
        data.source.runCommandAsync('tellraw @s[family=fault] {\"rawtext\":[{\"text\":\"§o§cDON\'T KILL TRADERS!...\"}]}')
        data.source.runCommandAsync('event entity @s[family=unskilled] slayer')
        data.source.runCommandAsync('event entity @s[family=totem] slayer')
        data.source.runCommandAsync('event entity @s[family=guardian] slayer')
        data.source.runCommandAsync('clear @s[family=unskilled] add:void_slayer 0 1')
        data.source.runCommandAsync('clear @s[family=totem] add:void_slayer 0 1')
        data.source.runCommandAsync('clear @s[family=guardian] add:void_slayer 0 1')
    }
})